/** 
 * @(#)Action.java
 */
package framework.action;

import java.io.IOException;
import java.io.PrintWriter;
import java.lang.reflect.Method;
import java.util.HashMap;
import java.util.Map;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import framework.config.Configuration;
import framework.db.ConnectionManager;

/** 
 * Ͻ  óϴ Ŭ ӹ޾ƾ  ߻Ŭ̴.
 * (jsp ) Ǳ  Ŭ̾Ʈ  ۵ ͸ ϰ  ݿϱ 
 *  ó(Pre-processing)̴. ϳ 񽺿    Ʈ · Ͽ   ִ. 
 * ۼ Actioin action.properties ϵȴ.
 */
public abstract class Action {
	private Map<String, ConnectionManager> _connMgrMap = new HashMap<String, ConnectionManager>();
	private HttpServlet _servlet = null;
	private Box _input = null;
	private Box _cookies = null;
	private MultipartBox _multipartInput = null;
	private PrintWriter _out = null;
	private HttpServletRequest _request = null;
	private HttpServletResponse _response = null;
	private static Log _logger = LogFactory.getLog(framework.action.Action.class);

	/** 
	 * Ŭ̾Ʈ 񽺸 ȣ  ûĶ action   Ͽ ش ޼ҵ带 Ѵ.
	 * ޼ҵ process  ξ Ͽ action ߰ Ī̴.
	 * ǵ  ޼ҵ带 ȣ  α׿ ޽ ϵǸ ޼ҵ  ģ  Ÿ̽  ڵ ݾش.
	 * <br>
	 * ex) action search ϶ => processSearch() ޼ҵ尡 ȣȴ.
	 * 
	 * @param servlet  ü
	 * @param request Ŭ̾Ʈ û Requestü
	 * @param response Ŭ̾Ʈ  Responseü
	 * @throws Exception 
	 */
	public void execute(HttpServlet servlet, HttpServletRequest request, HttpServletResponse response) throws Exception {
		setServlet(servlet);
		setRequest(request);
		setResponse(response);
		Method method = getMethod(request.getParameter("action"));
		if (method == null) {
			throw new PageNotFoundExeption("action");
		}
		try {
			method.invoke(this, (Object[]) null);
		} finally {
			destroy();
		}
	}

	/**
	 * û JSP (Forward) Ѵ.
	 * ۼ JSP  action.properties ϵȴ.
	 * <br>
	 * ex) Ű search-jsp  JSP    => route("search-jsp")
	 * 
	 * @param key action.properties Ͽ ϵ JSP  Ű
	 */
	protected void route(String key) {
		try {
			ActionRouter router = new ActionRouter(key);
			router.route(getServlet(), getRequest(), getResponse());
		} catch (Exception e) {
			getLogger().error("Router Error!", e);
		}
	}

	/** 
	 * û JSP (Forward) Ǵ (Redirect) Ѵ.
	 * ۼ JSP  action.properties ϵȴ.
	 * <br>
	 * ex1) Ű search-jsp  JSP    => route("search-jsp", true)
	 * <br>
	 * ex2) Ű search-jsp  JSP    => route("search-jsp", false)
	 * 
	 * @param key action.properties Ͽ ϵ JSP  Ű
	 * @param isForward true̸ (Forward), false ̸ (Redirect)
	 */
	protected void route(String key, boolean isForward) {
		try {
			ActionRouter router = new ActionRouter(key, isForward);
			router.route(getServlet(), getRequest(), getResponse());
		} catch (Exception e) {
			getLogger().error("Router Error!", e);
		}
	}

	/** 
	 * û JSP (Redirect) Ѵ.
	 * ۼ JSP  action.properties ϵȴ.
	 * <br>
	 * ex) Ű search-jsp  JSP    => redirect("search-jsp")
	 * 
	 * @param key action.properties Ͽ ϵ JSP  Ű
	 */
	protected void redirect(String key) {
		route(key, false);
	}

	/** 
	 * Ÿ̽ (ؼ Ŵ) ü Ѵ.
	 * <br>
	 * config.properties datasource ϵǾ  JNDI ϵǾִ Ÿҽ ؼ Ѵ.
	 * datasource ϵǾ  ʴ    jdbc ؼ Ѵ.
	 *  default شϴ   ̿Ͽ ؼ Ѵ.
	 *  ؼ autoCommit Ӽ false  õȴ.
	 *
	 * @return (ؼ Ŵ) ü
	 */
	protected ConnectionManager getConnectionManager() {
		return getConnectionManager("default");
	}

	/** 
	 * Ÿ̽ (ؼ Ŵ) ü Ѵ.
	 * <br>
	 * config.properties datasource ϵǾ  JNDI ϵǾִ Ÿҽ ؼ Ѵ.
	 * datasource ϵǾ  ʴ    jdbc ؼ Ѵ.
	 * Ķͷ Ѱ  شϴ   ̿Ͽ ؼ Ѵ.
	 *  ؼ autoCommit Ӽ false  õȴ.
	 *
	 * @param serviceName 񽺸()
	 * @return (ؼ Ŵ) ü
	 */
	protected ConnectionManager getConnectionManager(String serviceName) {
		if (!this._connMgrMap.containsKey(serviceName)) {
			String dsName = null;
			String jdbcDriver = null;
			String jdbcUrl = null;
			String jdbcUid = null;
			String jdbcPw = null;
			try {
				dsName = getConfig().getString("jdbc." + serviceName + ".datasource");
			} catch (Exception e) {
				// Ͽ Ÿҽ ǵǾ  
				jdbcDriver = getConfig().getString("jdbc." + serviceName + ".driver");
				jdbcUrl = getConfig().getString("jdbc." + serviceName + ".url");
				jdbcUid = getConfig().getString("jdbc." + serviceName + ".uid");
				jdbcPw = getConfig().getString("jdbc." + serviceName + ".pwd");
			}
			try {
				ConnectionManager connMgr = new ConnectionManager(dsName, this);
				if (dsName != null) {
					connMgr.connect();
				} else {
					connMgr.connect(jdbcDriver, jdbcUrl, jdbcUid, jdbcPw);
				}
				connMgr.setAutoCommit(false);
				this._connMgrMap.put(serviceName, connMgr);
			} catch (Exception e) {
				getLogger().error("DB Connection Error!", e);
			}
		}
		return this._connMgrMap.get(serviceName);
	}

	/** 
	 *   ִ ü Ͽ Ѵ.
	 *
	 * @return config.properties   ִ ü
	 */
	protected Configuration getConfig() {
		return Configuration.getInstance();
	}

	/** 
	 * Actionü ȣ  ü Ѵ.
	 *
	 * @return Actionü ȣ  ü
	 */
	protected HttpServlet getServlet() {
		return this._servlet;
	}

	/** 
	 * HTTP Ŭ̾Ʈ û ü Ѵ.
	 *
	 * @return HTTP Ŭ̾Ʈ ûü
	 */
	protected HttpServletRequest getRequest() {
		return this._request;
	}

	/** 
	 * HTTP Ŭ̾Ʈ  ü Ѵ.
	 *
	 * @return HTTP Ŭ̾Ʈ 䰴ü
	 */
	protected HttpServletResponse getResponse() {
		return this._response;
	}

	/** 
	 * Ŭ̾Ʈ  ü Ѵ.
	 * ̹  Ǿ ִ°   ϸ  °  Ͽ Ѵ. 
	 *
	 * @return Ŭ̾Ʈ  ü
	 */
	protected HttpSession getSession() {
		return getRequest().getSession();
	}

	/** 
	 * Ŭ̾Ʈ  ü Ѵ.
	 *  ° Ķ  true̸   ϸ false ̸  ʴ´. 
	 *
	 * @param create   true̸  , false̸  
	 * @return Ŭ̾Ʈ  ü
	 */
	protected HttpSession getSession(boolean create) {
		return getRequest().getSession(create);
	}

	/** 
	 * ǰü ش Ű شϴ Ʈ Ѵ.
	 * <br>
	 * ex) ǿ result Ű Ʈ Ϲ޴  => Object obj = getSessionAttribute("result")
	 *
	 * @param key ǰü ȸŰ
	 * @return ǰü  Ʈ
	 */
	protected Object getSessionAttribute(String key) {
		return getSession().getAttribute(key);
	}

	/** 
	 * ûĶ   ִ ؽ̺ Ѵ.
	 * <br>
	 * ex1) [ name=ȫ浿 ] ûĶ͸ ޾ƿ  => String name = getInput().getString("name")
	 * <br>
	 * ex2) [ age=20 ] ûĶ͸ ޾ƿ  => Integer age = getInput().getInteger("age")
	 *
	 * @return ûĶ   ؽ̺
	 */
	protected Box getInput() {
		if (this._input == null) {
			this._input = Box.getBox(getRequest());
		}
		return this._input;
	}

	/** 
	 * Multipart ûĶ   ִ ؽ̺ Ѵ.
	 * <br>
	 * ex1) [ name=ȫ浿 ] ûĶ͸ ޾ƿ  => String name = getMultipartInput().getString("name")
	 * <br>
	 * ex2) [ age=20 ] ûĶ͸ ޾ƿ  => Integer age = getMultipartInput().getInteger("age")
	 * <br>
	 * ex3) ۵ ϸ ޾ƿ  => List<FileItem> files = getMultipartInput().getFileItems()
	 * 
	 * @return ûĶ   ؽ̺
	 */
	protected MultipartBox getMultipartInput() {
		if (this._multipartInput == null) {
			this._multipartInput = MultipartBox.getMultipartBox(getRequest());
		}
		return this._multipartInput;
	}

	/** 
	 * Ű  ִ ؽ̺ Ѵ.
	 * <br>
	 * ex1) [ name=ȫ浿 ] Ű ޾ƿ  => String name = getCookies().getString("name")
	 * <br>
	 * ex2) [ age=20 ] Ű ޾ƿ  => Integer age = getCookies().getInteger("age")
	 *
	 * @return Ű  ؽ̺
	 */
	protected Box getCookies() {
		if (this._cookies == null) {
			this._cookies = Box.getBoxFromCookie(getRequest());
		}
		return this._cookies;
	}

	/** 
	 * 䰴ü PrintWriter ü Ѵ.
	 * <br>
	 * ex) 信 Hello World    => getOut().println("Hello World!")
	 *
	 * @return 䰴ü PrintWriter ü
	 */
	protected PrintWriter getOut() {
		if (this._out == null) {
			try {
				this._out = getResponse().getWriter();
			} catch (IOException e) {
			}
		}
		return this._out;
	}

	/** 
	 * Action ΰŰü Ѵ.
	 *  α״ ش ΰŸ ̿ؼ Ͽ Ѵ.
	 * <br>
	 * ex1)     => getLogger().error("...޽")
	 * <br>
	 * ex2)     => getLogger().debug("...׸޽")
	 *
	 * @return Action ΰŰü
	 */
	protected Log getLogger() {
		return Action._logger;
	}

	/**
	 * 䰴ü Ŭ̾Ʈ ϱ  Ÿ Ѵ. 
	 * <br>
	 * ex1) xml  ϴ  => setContentType("text/xml; charset=utf-8")
	 * <br>
	 * ex2) ؽƮ  ϴ  => setContentType("text/plain; charset=euc-kr")
	 *
	 * @param contentType 䰴ü   Ÿ
	 */
	protected void setContentType(String contentType) {
		getResponse().setContentType(contentType);
	}

	/** 
	 * ûü Ű, Ӽ Ѵ.
	 * Action ó    ѱ涧 ûü Ӽ Ͽ Ѵ.
	 * <br>
	 * ex) rs RecordSet ü result  Ű ûü ϴ  => setAttribute("result", re) 
	 *
	 * @param key Ӽ Ű ڿ
	 * @param value Ӽ  ü
	 */
	protected void setAttribute(String key, Object value) {
		getRequest().setAttribute(key, value);
	}

	/** 
	 * ǰü Ű, Ӽ Ѵ.
	 * Action ó  ǿ Ѵ.
	 * <br>
	 * ex) userinfo  ü userinfo  Ű ǰü ϴ  => setSessionAttribute("userinfo", userinfo)
	 *
	 * @param key Ӽ Ű ڿ
	 * @param value Ӽ  ü
	 */
	protected void setSessionAttribute(String key, Object value) {
		getSession().setAttribute(key, value);
	}

	//////////////////////////////////////////////////////////////////////////////////////////Private ޼ҵ
	private void setServlet(HttpServlet servlet) {
		this._servlet = servlet;
	}

	private void setRequest(HttpServletRequest req) {
		this._request = req;
	}

	private void setResponse(HttpServletResponse res) {
		this._response = res;
	}

	private void destroy() {
		ConnectionManager connMgr = null;
		for (String key : this._connMgrMap.keySet()) {
			connMgr = this._connMgrMap.get(key);
			if (connMgr != null) {
				connMgr.release();
				connMgr = null;
			}
		}
		this._connMgrMap.clear();
		this._input = null;
		this._out = null;
	}

	private Method getMethod(String methodName) {
		if (methodName == null || methodName.trim().equals("")) {
			methodName = "init";
		}
		StringBuilder sb = new StringBuilder(methodName);
		sb.setCharAt(0, Character.toUpperCase(methodName.charAt(0)));
		String name = "process" + sb.toString().trim();
		Method m = getMethod(this.getClass(), name);
		return m;
	}

	private static Method getMethod(Class<?> actionClass, String methodName) {
		Method method[] = actionClass.getMethods();
		for (int i = 0; i < method.length; i++) {
			if (method[i].getName().equals(methodName)) {
				return method[i];
			}
		}
		return null;
	}
}